/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentifierInputWrapper type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentifierInputWrapper{}

// IdentifierInputWrapper struct for IdentifierInputWrapper
type IdentifierInputWrapper struct {
	IdentifierName   NullableString `json:"identifierName,omitempty"`
	IdentifierValues []string       `json:"identifierValues,omitempty"`
}

// NewIdentifierInputWrapper instantiates a new IdentifierInputWrapper object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentifierInputWrapper() *IdentifierInputWrapper {
	this := IdentifierInputWrapper{}
	return &this
}

// NewIdentifierInputWrapperWithDefaults instantiates a new IdentifierInputWrapper object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentifierInputWrapperWithDefaults() *IdentifierInputWrapper {
	this := IdentifierInputWrapper{}
	return &this
}

// GetIdentifierName returns the IdentifierName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentifierInputWrapper) GetIdentifierName() string {
	if o == nil || IsNil(o.IdentifierName.Get()) {
		var ret string
		return ret
	}
	return *o.IdentifierName.Get()
}

// GetIdentifierNameOk returns a tuple with the IdentifierName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentifierInputWrapper) GetIdentifierNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentifierName.Get(), o.IdentifierName.IsSet()
}

// HasIdentifierName returns a boolean if a field has been set.
func (o *IdentifierInputWrapper) HasIdentifierName() bool {
	if o != nil && o.IdentifierName.IsSet() {
		return true
	}

	return false
}

// SetIdentifierName gets a reference to the given NullableString and assigns it to the IdentifierName field.
func (o *IdentifierInputWrapper) SetIdentifierName(v string) {
	o.IdentifierName.Set(&v)
}

// SetIdentifierNameNil sets the value for IdentifierName to be an explicit nil
func (o *IdentifierInputWrapper) SetIdentifierNameNil() {
	o.IdentifierName.Set(nil)
}

// UnsetIdentifierName ensures that no value is present for IdentifierName, not even an explicit nil
func (o *IdentifierInputWrapper) UnsetIdentifierName() {
	o.IdentifierName.Unset()
}

// GetIdentifierValues returns the IdentifierValues field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentifierInputWrapper) GetIdentifierValues() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.IdentifierValues
}

// GetIdentifierValuesOk returns a tuple with the IdentifierValues field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentifierInputWrapper) GetIdentifierValuesOk() ([]string, bool) {
	if o == nil || IsNil(o.IdentifierValues) {
		return nil, false
	}
	return o.IdentifierValues, true
}

// HasIdentifierValues returns a boolean if a field has been set.
func (o *IdentifierInputWrapper) HasIdentifierValues() bool {
	if o != nil && !IsNil(o.IdentifierValues) {
		return true
	}

	return false
}

// SetIdentifierValues gets a reference to the given []string and assigns it to the IdentifierValues field.
func (o *IdentifierInputWrapper) SetIdentifierValues(v []string) {
	o.IdentifierValues = v
}

func (o IdentifierInputWrapper) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentifierInputWrapper) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.IdentifierName.IsSet() {
		toSerialize["identifierName"] = o.IdentifierName.Get()
	}
	if o.IdentifierValues != nil {
		toSerialize["identifierValues"] = o.IdentifierValues
	}
	return toSerialize, nil
}

type NullableIdentifierInputWrapper struct {
	value *IdentifierInputWrapper
	isSet bool
}

func (v NullableIdentifierInputWrapper) Get() *IdentifierInputWrapper {
	return v.value
}

func (v *NullableIdentifierInputWrapper) Set(val *IdentifierInputWrapper) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentifierInputWrapper) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentifierInputWrapper) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentifierInputWrapper(val *IdentifierInputWrapper) *NullableIdentifierInputWrapper {
	return &NullableIdentifierInputWrapper{value: val, isSet: true}
}

func (v NullableIdentifierInputWrapper) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentifierInputWrapper) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
